[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index] [List Home]
[p2-dev] A.PDE.Target.Platform.

Do you remember the discussions around A.PDE.Target.Platform.? It's a very old discussion and the current solution is just a hack. A very clever hack I have to admit! ;-)

Anyway, I'd like to bring this up on this list again in the hope that we can find a better way to solve this, a real solution. Or maybe something changed in the meantime and I haven't found it yet - in that case just point me into the right direction.


Background:

We want to prevent users from (accidentally) installing IUs that are meant to go into a target platform into their IDEs (see [1]). If we take the RAP project as an example, it provides alternative implementations of org.eclipse.swt and cannot be installed together with the standard swt bundles.

The recommended workaround is to use a p2.inf file to add an additional dependency that cannot be met by the IDE (the dependency to 'A.PDE.Target.Platform.')
If an end user tries to install such an IU into his IDE, he will see a p2 failure and a cryptic message that he cannot install this IU.
If a developer wants to create a target platform with p2, he manually needs to deselect the 'Include required software' checkbox in the 'Add Software Site' wizard. All this is not very intuitive and leads to a lot of confusion.


And now?

I'd like to bring this up again and hope that we can find a real solution, maybe in the Juno time frame, maybe for Kepler.

Some suggested to define another windowing system for RAP [2] but this has its own drawbacks (and would solve only parts of this problem).

The best solution seems to me a negative p2 requirement (see [3]), but these are not supported in p2.inf files.


Any thoughts on this? Other suggestions?



[1] https://bugs.eclipse.org/bugs/show_bug.cgi?id=276000
[target] Prevent SDK features from being installed into IDE

[2] https://bugs.eclipse.org/bugs/show_bug.cgi?id=338544
Use Equinox PlatformFilter to prevent RAP installed into the IDE

[3] https://bugs.eclipse.org/bugs/show_bug.cgi?id=365004#c9
improve "runtime only" handling


Thanks,
Markus